// Dialog_ChangeDescription.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef DIALOG_CHANGEDESCRIPTION_H
#define DIALOG_CHANGEDESCRIPTION_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
wstring changedesc_filename;
wstring changedesc_olddesc;
wstring changedesc_newdesc;
///////////////////////////////////////////////////////////
BOOL CALLBACK DlgProc_ChangeDescription( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
	switch( message ) {
		case WM_INITDIALOG: {
		/* wParam
				Handle to the control to receive the default keyboard focus. The system assigns the default keyboard focus only if the dialog box procedure returns TRUE. 
			lParam
				Specifies additional initialization data. This data is passed to the system as the lParam parameter in a call to the CreateDialogIndirectParam, CreateDialogParam, DialogBoxIndirectParam, or DialogBoxParam function used to create the dialog box. For property sheets, this parameter is a pointer to the PROPSHEETPAGE structure used to create the page. This parameter is zero if any other dialog box creation function is used. 
			Return: TRUE if we want to set keyboard focus to wParam, FALSE otherwise.
		*/
			SendDlgItemMessage( hWnd, IDC_CHANGEDESCRIPTION_FILE, WM_SETTEXT, 0, (LPARAM)changedesc_filename.c_str() );
			SendDlgItemMessage( hWnd, IDC_CHANGEDESCRIPTION_DESC, WM_SETTEXT, 0, (LPARAM)changedesc_olddesc.c_str() );
			SendDlgItemMessage( hWnd, IDC_CHANGEDESCRIPTION_EDIT, WM_SETTEXT, 0, (LPARAM)changedesc_newdesc.c_str() );

			return(TRUE);
		}
		case WM_COMMAND: {
			switch( LOWORD(wParam) ) {
				case IDOK: {
					Uint16 str[5000];
					GetDlgItemText( hWnd, IDC_CHANGEDESCRIPTION_EDIT, str, 5000-1 );
						changedesc_newdesc = str;
					EndDialog( hWnd, IDOK );
					break;
				}
				case IDCANCEL: {
					EndDialog( hWnd, IDCANCEL );
					break;
            }
			}
			return(TRUE);
		}
   }
	// Returning FALSE causes it to do the default processing for the message.
   return(FALSE); 
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
int CreateDialog_ChangeDescription( HWND hwndParent, Dictionary_EDICT *edict ) {
	changedesc_filename = ToWString( edict->filename );
	changedesc_olddesc = ToWString( edict->displayname );
	changedesc_newdesc = changedesc_olddesc;
	int result = DialogBox(
		g_hinst,
		MAKEINTRESOURCE( IDD_CHANGEDESCRIPTION ), 
		hwndParent,
		(DLGPROC)DlgProc_ChangeDescription
	);
	if( result == IDOK ) {
		edict->displayname = ToString( changedesc_newdesc );
	}
	return( result );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
