// Dialog_Options_ResultWindow.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef DIALOG_OPTIONS_RESULTWINDOW_H
#define DIALOG_OPTIONS_RESULTWINDOW_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
Color options_color_result_bg( color_result_bg1 );
HBRUSH hbrush_result = CreateSolidBrush( options_color_result_bg.ToCOLORREF() );
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
BOOL CALLBACK DlgProc_Options_ResultWindow( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam ) {
	switch( message ) {
		case WM_INITDIALOG: {
		/* wParam
				Handle to the control to receive the default keyboard focus. The system assigns the default keyboard focus only if the dialog box procedure returns TRUE. 
			lParam
				Specifies additional initialization data. This data is passed to the system as the lParam parameter in a call to the CreateDialogIndirectParam, CreateDialogParam, DialogBoxIndirectParam, or DialogBoxParam function used to create the dialog box. For property sheets, this parameter is a pointer to the PROPSHEETPAGE structure used to create the page. This parameter is zero if any other dialog box creation function is used. 
			Return: TRUE if we want to set keyboard focus to wParam, FALSE otherwise.
		*/

			// Set the text of the font boxes:
			Uint16 str[1024];
				swprintf(str,L"%S, %i pt.",registry.GetSTRING(".\\Results\\Fonts\\Word\\Font"), registry.GetINT(".\\Results\\Fonts\\Word\\Size") );
			SendDlgItemMessage( hWnd, IDC_RESULTWINDOW_WORD, WM_SETTEXT, 0, (LPARAM)str );
				swprintf(str,L"%S, %i pt.",registry.GetSTRING(".\\Results\\Fonts\\Kana\\Font"), registry.GetINT(".\\Results\\Fonts\\Kana\\Size") );
			SendDlgItemMessage( hWnd, IDC_RESULTWINDOW_KANA, WM_SETTEXT, 0, (LPARAM)str );
				swprintf(str,L"%S, %i pt.",registry.GetSTRING(".\\Results\\Fonts\\Meaning\\Font"), registry.GetINT(".\\Results\\Fonts\\Meaning\\Size") );
			SendDlgItemMessage( hWnd, IDC_RESULTWINDOW_MEANING, WM_SETTEXT, 0, (LPARAM)str );
				swprintf(str,L"%S, %i pt.",registry.GetSTRING(".\\Results\\Fonts\\Info\\Font"), registry.GetINT(".\\Results\\Fonts\\Info\\Size") );
			SendDlgItemMessage( hWnd, IDC_RESULTWINDOW_INFO, WM_SETTEXT, 0, (LPARAM)str );

			// Check the radio button for 'Background (1)':
			SendDlgItemMessage( hWnd, IDC_RESULTWINDOW_RADIO_BG1, BM_SETCHECK, BST_CHECKED, 0 );
			options_color_result_bg = color_result_bg1;

			return(TRUE);
		}
		case WM_COMMAND: {
			WORD identifier = LOWORD(wParam);
			WORD code = HIWORD(wParam);
			switch( identifier ) {
				case IDC_RESULTWINDOW_FONT_WORD:
				case IDC_RESULTWINDOW_FONT_KANA:
				case IDC_RESULTWINDOW_FONT_MEANING:
				case IDC_RESULTWINDOW_FONT_INFO: {
				/*		The 'Font' button for Word\Kana\Meaning\Info was clicked.
					We need to pop up a choose-font box so he can choose the font.
					If a font was chosen ('ok'), then we need to update the registry
					and update the font that the result window uses.
				*/
					switch( code ) {
						case BN_CLICKED: {
							CHOOSEFONT cf;
								cf.lStructSize = sizeof(CHOOSEFONT);
								cf.hwndOwner = hWnd;
								cf.Flags = CF_FORCEFONTEXIST|CF_SCREENFONTS|CF_INITTOLOGFONTSTRUCT|CF_LIMITSIZE;
								static LOGFONT lf;
									switch( identifier ) {
										case IDC_RESULTWINDOW_FONT_WORD: {
											wcscpy( lf.lfFaceName, ToWString( registry.GetSTRING(".\\Results\\Fonts\\Word\\Font") ).c_str() );
											lf.lfHeight = -MulDiv( registry.GetINT(".\\Results\\Fonts\\Word\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72);
											break;
										}
										case IDC_RESULTWINDOW_FONT_KANA: {
											wcscpy( lf.lfFaceName, ToWString( registry.GetSTRING(".\\Results\\Fonts\\Kana\\Font") ).c_str() );
											lf.lfHeight = -MulDiv( registry.GetINT(".\\Results\\Fonts\\Kana\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72);
											break;
										}
										case IDC_RESULTWINDOW_FONT_MEANING: {
											wcscpy( lf.lfFaceName, ToWString( registry.GetSTRING(".\\Results\\Fonts\\Meaning\\Font") ).c_str() );
											lf.lfHeight = -MulDiv( registry.GetINT(".\\Results\\Fonts\\Meaning\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72);
											break;
										}
										case IDC_RESULTWINDOW_FONT_INFO: {
											wcscpy( lf.lfFaceName, ToWString( registry.GetSTRING(".\\Results\\Fonts\\Info\\Font") ).c_str() );
											lf.lfHeight = -MulDiv( registry.GetINT(".\\Results\\Fonts\\Info\\Size"), GetDeviceCaps(GetDC(hwnd_resultwindow), LOGPIXELSY), 72);
											break;
										}
									}
									lf.lfWeight = FW_NORMAL;
									lf.lfItalic = FALSE;
									lf.lfUnderline = FALSE;
									lf.lfStrikeOut = FALSE;
									lf.lfCharSet = SHIFTJIS_CHARSET;
								cf.lpLogFont = &lf;
								cf.nSizeMin = 6;
								cf.nSizeMax = 100;
							// Show the choose-font window:
							if( ChooseFont( &cf ) ) {
							// If the clicked 'ok'...
								switch( identifier ) {
									case IDC_RESULTWINDOW_FONT_WORD: {
										// Kill the old font and make the new one:
										DeleteObject( hfont_result_word );
										hfont_result_word = CreateFontIndirect( &lf );

										// Set the new values:
										registry.SetSTRING(".\\Results\\Fonts\\Word\\Font", ToString(lf.lfFaceName).c_str() );
										registry.SetINT(".\\Results\\Fonts\\Word\\Size", (cf.iPointSize/10) );
								
										// Set the text of the box:
										Uint16 str[1024];
											swprintf(str,L"%S, %i pt.",registry.GetSTRING(".\\Results\\Fonts\\Word\\Font"), registry.GetINT(".\\Results\\Fonts\\Word\\Size") );
										SendDlgItemMessage( hWnd, IDC_RESULTWINDOW_WORD, WM_SETTEXT, 0, (LPARAM)str );
										break;
									}
									case IDC_RESULTWINDOW_FONT_KANA: {
										// Kill the old font and make the new one:
										DeleteObject( hfont_result_kana );
										hfont_result_kana = CreateFontIndirect( &lf );

										// Set the new values:
										registry.SetSTRING(".\\Results\\Fonts\\Kana\\Font", ToString(lf.lfFaceName).c_str() );
										registry.SetINT(".\\Results\\Fonts\\Kana\\Size", (cf.iPointSize/10) );
								
										// Set the text of the box:
										Uint16 str[1024];
											swprintf(str,L"%S, %i pt.",registry.GetSTRING(".\\Results\\Fonts\\Kana\\Font"), registry.GetINT(".\\Results\\Fonts\\Kana\\Size") );
										SendDlgItemMessage( hWnd, IDC_RESULTWINDOW_KANA, WM_SETTEXT, 0, (LPARAM)str );
										break;
									}
									case IDC_RESULTWINDOW_FONT_MEANING: {
										// Kill the old font and make the new one:
										DeleteObject( hfont_result_meaning );
										hfont_result_meaning = CreateFontIndirect( &lf );

										// Set the new values:
										registry.SetSTRING(".\\Results\\Fonts\\Meaning\\Font", ToString(lf.lfFaceName).c_str() );
										registry.SetINT(".\\Results\\Fonts\\Meaning\\Size", (cf.iPointSize/10) );
								
										// Set the text of the box:
										Uint16 str[1024];
											swprintf(str,L"%S, %i pt.",registry.GetSTRING(".\\Results\\Fonts\\Meaning\\Font"), registry.GetINT(".\\Results\\Fonts\\Meaning\\Size") );
										SendDlgItemMessage( hWnd, IDC_RESULTWINDOW_MEANING, WM_SETTEXT, 0, (LPARAM)str );
										break;
									}
									case IDC_RESULTWINDOW_FONT_INFO: {
										// Kill the old font and make the new one:
										DeleteObject( hfont_result_info );
										hfont_result_info = CreateFontIndirect( &lf );

										// Set the new values:
										registry.SetSTRING(".\\Results\\Fonts\\Info\\Font", ToString(lf.lfFaceName).c_str() );
										registry.SetINT(".\\Results\\Fonts\\Info\\Size", (cf.iPointSize/10) );
								
										// Set the text of the box:
										Uint16 str[1024];
											swprintf(str,L"%S, %i pt.",registry.GetSTRING(".\\Results\\Fonts\\Info\\Font"), registry.GetINT(".\\Results\\Fonts\\Info\\Size") );
										SendDlgItemMessage( hWnd, IDC_RESULTWINDOW_INFO, WM_SETTEXT, 0, (LPARAM)str );
										break;
									}
								}

								// Redraw the results window:
								// (We need to resize it to get the sizes right (new fonts).)
								RECT rc;
									GetWindowRect( hwnd_resultwindow, &rc );
								SendMessage( hwnd_resultwindow, WM_SIZE, SIZE_RESTORED, MAKELPARAM(rc.right-rc.left,rc.bottom-rc.top) );
								// Redraw it:
								RedrawWindow( hwnd_resultwindow, NULL, NULL, RDW_INVALIDATE );
							}
							break;
						}
					}
					break;
				}
				case IDC_RESULTWINDOW_COLOR_WORD:
				case IDC_RESULTWINDOW_COLOR_KANA:
				case IDC_RESULTWINDOW_COLOR_MEANING:
				case IDC_RESULTWINDOW_COLOR_INFO: {
				/*		The 'Color' button for word\kana\meaning\info was
					clicked.  Pick a new word color.
				*/
					switch( code ) {
						case BN_CLICKED: {
							// The custom-color array:
							static COLORREF colorref_array[16];
							// The choose-color structure:
							CHOOSECOLOR ch;
								ch.lStructSize = sizeof(CHOOSECOLOR);
								ch.hwndOwner = hWnd;
								switch( identifier ) {
									case IDC_RESULTWINDOW_COLOR_WORD: {
										ch.rgbResult = color_result_word.ToCOLORREF();
										break;
									}
									case IDC_RESULTWINDOW_COLOR_KANA: {
										ch.rgbResult = color_result_kana.ToCOLORREF();
										break;
									}
									case IDC_RESULTWINDOW_COLOR_MEANING: {
										ch.rgbResult = color_result_meaning.ToCOLORREF();
										break;
									}
									case IDC_RESULTWINDOW_COLOR_INFO: {
										ch.rgbResult = color_result_info.ToCOLORREF();
										break;
									}
								}
								ch.lpCustColors = colorref_array;
								ch.Flags = CC_RGBINIT|CC_FULLOPEN|CC_PREVENTFULLOPEN|CC_ANYCOLOR;
							// Open up the dialog box:
							if( ChooseColor(&ch) ) {
							// If he clicked on 'ok'...
								switch( identifier ) {
									case IDC_RESULTWINDOW_COLOR_WORD: {
										// Set the color:
										color_result_word.SetFromCOLORREF(ch.rgbResult);
										registry.SetINT(".\\Results\\Fonts\\Word\\Color",ch.rgbResult );

										// Redraw the text area:
										RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_WORD), NULL, NULL, RDW_INVALIDATE );
										break;
									}
									case IDC_RESULTWINDOW_COLOR_KANA: {
										// Set the color:
										color_result_kana.SetFromCOLORREF(ch.rgbResult);
										registry.SetINT(".\\Results\\Fonts\\Kana\\Color",ch.rgbResult );

										// Redraw the text area:
										RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_KANA), NULL, NULL, RDW_INVALIDATE );
										break;
									}
									case IDC_RESULTWINDOW_COLOR_MEANING: {
										// Set the color:
										color_result_meaning.SetFromCOLORREF(ch.rgbResult);
										registry.SetINT(".\\Results\\Fonts\\Meaning\\Color",ch.rgbResult );

										// Redraw the text area:
										RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_MEANING), NULL, NULL, RDW_INVALIDATE );
										break;
									}
									case IDC_RESULTWINDOW_COLOR_INFO: {
										// Set the color:
										color_result_info.SetFromCOLORREF(ch.rgbResult);
										registry.SetINT(".\\Results\\Fonts\\Info\\Color",ch.rgbResult );

										// Redraw the text area:
										RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_INFO), NULL, NULL, RDW_INVALIDATE );
										break;
									}
								}
								// Redraw the results window:
								RedrawWindow( hwnd_resultwindow, NULL, NULL, RDW_INVALIDATE );
							}
							break;
						}
					}
					break;
				}
				case IDC_RESULTWINDOW_RADIO_BG1: {
				/*		When he clicks on 'Background (1)', set the background color
					of the edit boxes to the Result Window's color_bg.
				*/
					switch( HIWORD(wParam) ) {
						case BN_CLICKED: {
							if( IsDlgButtonChecked( hWnd, IDC_RESULTWINDOW_RADIO_BG1 ) ) {
								// Set the color:
								options_color_result_bg = color_result_bg1;
								// Delete and remake the brush:
								DeleteObject( hbrush_result );
								hbrush_result = CreateSolidBrush( options_color_result_bg.ToCOLORREF() );
								// Redraw the windows:
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_WORD), NULL, NULL, RDW_INVALIDATE );
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_KANA), NULL, NULL, RDW_INVALIDATE );
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_MEANING), NULL, NULL, RDW_INVALIDATE );
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_INFO), NULL, NULL, RDW_INVALIDATE );
							}
							break;
						}
					}
					break;
				}
				case IDC_RESULTWINDOW_RADIO_BG2: {
				/*		When he clicks on 'Background (2)', set the background color
					of the edit boxes to the Result Window's color_bg2.
				*/
					switch( HIWORD(wParam) ) {
						case BN_CLICKED: {
							if( IsDlgButtonChecked( hWnd, IDC_RESULTWINDOW_RADIO_BG2 ) ) {
								// Set the color:
								options_color_result_bg = color_result_bg2;
								// Delete and remake the brush:
								DeleteObject( hbrush_result );
								hbrush_result = CreateSolidBrush( options_color_result_bg.ToCOLORREF() );
								// Redraw the windows:
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_WORD), NULL, NULL, RDW_INVALIDATE );
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_KANA), NULL, NULL, RDW_INVALIDATE );
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_MEANING), NULL, NULL, RDW_INVALIDATE );
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_INFO), NULL, NULL, RDW_INVALIDATE );
							}
							break;
						}
					}
					break;
				}
				case IDC_RESULTWINDOW_COLOR_BG: {
				/*		When the background 'Color' button is clicked, pick a new background
					color for the currently selected background mode.
				*/
					switch( HIWORD(wParam) ) {
						case BN_CLICKED: {
							// Find out what button (1 or 2) is pressed:
							int mode = IsDlgButtonChecked( hWnd, IDC_RESULTWINDOW_RADIO_BG1 )?1:2;
							// The custom-color array:
							static COLORREF colorref_array[16];
							// The choose-color structure:
							CHOOSECOLOR ch;
								ch.lStructSize = sizeof(CHOOSECOLOR);
								ch.hwndOwner = hWnd;
								ch.rgbResult = options_color_result_bg.ToCOLORREF();
								ch.lpCustColors = colorref_array;
								ch.Flags = CC_RGBINIT|CC_FULLOPEN|CC_PREVENTFULLOPEN|CC_ANYCOLOR;
							// Open up the dialog box:
							if( ChooseColor(&ch) ) {
							// If he clicked on 'ok'...
								if( mode == 1 ) {									
									color_result_bg1.SetFromCOLORREF(ch.rgbResult);
									options_color_result_bg = color_result_bg1;
									registry.SetINT(".\\Results\\Colors\\BG1",ch.rgbResult );
								} else {
									color_result_bg2.SetFromCOLORREF(ch.rgbResult);
									options_color_result_bg = color_result_bg2;
									registry.SetINT(".\\Results\\Colors\\BG2",ch.rgbResult );
								}
								// Delete the brush and re-make it:
								DeleteObject( hbrush_result );
								hbrush_result = CreateSolidBrush( options_color_result_bg.ToCOLORREF() );
								// Redraw the text areas:
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_WORD), NULL, NULL, RDW_INVALIDATE );
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_KANA), NULL, NULL, RDW_INVALIDATE );
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_MEANING), NULL, NULL, RDW_INVALIDATE );
								RedrawWindow( GetDlgItem(hWnd,IDC_RESULTWINDOW_INFO), NULL, NULL, RDW_INVALIDATE );
								// Redraw the results window:
								RedrawWindow( hwnd_resultwindow, NULL, NULL, RDW_INVALIDATE );
							}
							break;
						}
					}
					break;
				}
				case IDC_RESULTWINDOW_COLOR_WINDOW:
				case IDC_RESULTWINDOW_COLOR_BORDER_OUTSIDE:
				case IDC_RESULTWINDOW_COLOR_BORDER_INSIDE: {
				/*		The 'Color' button for the:
					* inside border
					* outside border
					* window
					was clicked.  Pick a new color.
				*/
					switch( code ) {
						case BN_CLICKED: {
							// The custom-color array:
							static COLORREF colorref_array[16];
							// The choose-color structure:
							CHOOSECOLOR ch;
								ch.lStructSize = sizeof(CHOOSECOLOR);
								ch.hwndOwner = hWnd;
								switch( identifier ) {
									case IDC_RESULTWINDOW_COLOR_BORDER_OUTSIDE: {
										ch.rgbResult = color_result_border_outside.ToCOLORREF();
										break;
									}
									case IDC_RESULTWINDOW_COLOR_BORDER_INSIDE: {
										ch.rgbResult = color_result_border_inside.ToCOLORREF();
										break;
									}
									case IDC_RESULTWINDOW_COLOR_WINDOW: {
										ch.rgbResult = color_result_windowbg.ToCOLORREF();
										break;
									}
								}
								ch.lpCustColors = colorref_array;
								ch.Flags = CC_RGBINIT|CC_FULLOPEN|CC_PREVENTFULLOPEN|CC_ANYCOLOR;
							// Open up the dialog box:
							if( ChooseColor(&ch) ) {
							// If he clicked on 'ok'...
								switch( identifier ) {
									case IDC_RESULTWINDOW_COLOR_BORDER_OUTSIDE: {
										// Set the color:
										color_result_border_outside.SetFromCOLORREF(ch.rgbResult);
										registry.SetINT(".\\Results\\Colors\\Border_Outside",ch.rgbResult );
										break;
									}
									case IDC_RESULTWINDOW_COLOR_BORDER_INSIDE: {
										// Set the color:
										color_result_border_inside.SetFromCOLORREF(ch.rgbResult);
										registry.SetINT(".\\Results\\Colors\\Border_Inside",ch.rgbResult );
										break;
									}
									case IDC_RESULTWINDOW_COLOR_WINDOW: {
										// Set the color:
										color_result_windowbg.SetFromCOLORREF(ch.rgbResult);
										registry.SetINT(".\\Results\\Colors\\BGWindow",ch.rgbResult );
										break;
									}
								}
								// Redraw the results window:
								RedrawWindow( hwnd_resultwindow, NULL, NULL, RDW_INVALIDATE );
							}
							break;
						}
					}
					break;
				}
			}
			return(TRUE);
		}
		case WM_CTLCOLORSTATIC: {
		/*		This message is sent when an edit box needs to be drawn.
			It gives you the ability to set the foreground and background colors.
			Also, you return the brush that you want use to color the rest
			(non-text) areas.
		*/
			HDC hdc_edit = (HDC)wParam;
			HWND hwnd_edit = (HWND)lParam;

			switch( GetDlgCtrlID(hwnd_edit) ) {
				case IDC_RESULTWINDOW_WORD: {
					SetTextColor( hdc_edit, color_result_word.ToCOLORREF() );
					SetBkColor( hdc_edit, options_color_result_bg.ToCOLORREF() );
					return( (BOOL)hbrush_result );
				}
				case IDC_RESULTWINDOW_KANA: {
					SetTextColor( hdc_edit, color_result_kana.ToCOLORREF() );
					SetBkColor( hdc_edit, options_color_result_bg.ToCOLORREF() );
					return( (BOOL)hbrush_result );
				}
				case IDC_RESULTWINDOW_MEANING: {
					SetTextColor( hdc_edit, color_result_meaning.ToCOLORREF() );
					SetBkColor( hdc_edit, options_color_result_bg.ToCOLORREF() );
					return( (BOOL)hbrush_result );
				}
				case IDC_RESULTWINDOW_INFO: {
					SetTextColor( hdc_edit, color_result_info.ToCOLORREF() );
					SetBkColor( hdc_edit, options_color_result_bg.ToCOLORREF() );
					return( (BOOL)hbrush_result );
				}
			}
			return(FALSE);
		}
	}
	// Returning FALSE causes it to do the default processing for the message.
   return(FALSE); 
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
HWND CreateDialog_Options_ResultWindow( HWND hwndParent ) {
	HWND hwnd = CreateDialog(
		g_hinst,
		MAKEINTRESOURCE( IDD_OPTIONS_RESULTWINDOW ), 
		hwndParent,
		(DLGPROC)DlgProc_Options_ResultWindow
	);
	return( hwnd );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
