// Edict_markers.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef EDICT_MARKERS_H
#define EDICT_MARKERS_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
struct EDICT_Marker {
	wstring marker;
	wstring meaning;
};
///////////////////////////////////////////////////////////
vector<EDICT_Marker> EDICT_Markers;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void LoadMarkers() {
	FILE *fin = fopen( "partsofspeech.jlf","rt" );

	while( !feof(fin) ) {
		char line[1024];
		fgets(line,1024-1,fin);
		if( feof(fin) ) {  break;  }
		line[strlen(line)-1] = '\0';
		if( line[0] == '#' ) {
			continue;
		}

		string strline = line;
		int pos = strline.find(0x09); // (tab)

		EDICT_Marker em;
			em.marker = ToWString( strline.substr(0,pos) );
			em.meaning = ToWString( strline.substr(pos+1,-1) );
		EDICT_Markers.push_back( em );
	}
	fclose(fin);
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
wstring GetInfo( wstring text ) {
	for( int i = 0; i < EDICT_Markers.size(); i++ ) {
		if( text == EDICT_Markers[i].marker ) {
			return( EDICT_Markers[i].meaning );
		}
	}
	return(L"");
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void SetInfo( EDICT_Entry &entry ) {
	// If there's nothing to set, quit:
	if( entry.meaning.size() == 0 ) {  return;  }

	wstring line1 = entry.meaning[0];
	while( line1[0] == L'(' ) {
		int end = line1.find( L')', 1 );
		wstring stuff = line1.substr( 1,end-1 );
		bool foundinfo = false;
		while( true ) {
			int next = stuff.find( L',' );

			wstring part = stuff.substr(0,next);
			wstring info = GetInfo( part );
			if( info != L"" ) {
				//entry.info.push_back(part);
				entry.info.push_back(info);
				foundinfo = true;
			}
			
			if( next == -1 ) {
				break;
			} else {
				stuff = stuff.substr( next+1,-1 );
			}
		}
		line1 = line1.substr( end+1 + 1,-1 );
		if( foundinfo ) {
			entry.meaning[0] = line1;
		}
	}

	// Some of them hid inside the entries:
	// So, go through them all:
	for( int i = 0; i < entry.meaning.size(); i++ ) {
		int start = 0;
		wstring stuff = entry.meaning[i];
		bool foundinfo = false;
		// Break the line down bit by bit:
		while( start >= 0 ) {
			int pos = stuff.find( L'(', start );
				if( pos == -1 ) {  break;  }
			int pos2 = stuff.find( L')', start );
				if( pos2 == -1 ) {  break;  }


			// Break the part in parentheses down bit by bit:
			wstring part = stuff.substr( pos+1,pos2-pos-1 );
			bool foundinfo2 = false;
			while( true ) {
				int next = part.find( L',' );

				wstring part2 = part.substr(0,next);
				wstring info = GetInfo( part2 );
				if( info != L"" ) {
					//entry.info.push_back(part2);
					entry.info.push_back( info );
					foundinfo2 = true;
				}

				if( next == -1 ) {
					break;
				} else {
					part = part.substr( next+1,-1 );
				}
			}
			if( foundinfo2 ) {
				foundinfo = true;

				bool b = false;  if( pos2+1 < stuff.size()-1 ) {  b = true;  }
				stuff = stuff.substr( 0,pos ); + (pos2+1<stuff.size()-1)?stuff.substr( pos2+1,-1 ) : wstring(L"");
				if( b ) {  break;  }
			}//*/
			start = pos2+1;
		}
		if( foundinfo ) {
			entry.meaning[i] = stuff;
		}
	}

	if( entry.meaning[ entry.meaning.size()-1 ] == L"(P)" ) {
		entry.meaning.pop_back();
		//entry.info.push_back(L"(P)");
		entry.info.push_back(L"One of top 20,000 words");
	}
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////