// Header.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef HEADER_H
#define HEADER_H
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
int Header_GetWidth( HWND hwndList ) {
	int numitems = Header_GetItemCount( hwndList );
	int w = 0;
	for( int i = 0; i < numitems; i++ ) {
		RECT rcHeaderItem;
			Header_GetItemRect( hwndList, i, &rcHeaderItem );
		w += rcHeaderItem.right-rcHeaderItem.left;
	}
	return(w);
}
///////////////////////////////////////////////////////////
//void Header_AddItem( HWND hwndList, TCHAR* text, int w ) {
void Header_AddItem( HWND hwndList, LPTSTR text, int w ) {
	HDITEM hdi;
		hdi.mask = HDI_TEXT | HDI_FORMAT | HDI_WIDTH | HDI_LPARAM;
		hdi.fmt = HDF_LEFT | HDF_STRING;
		hdi.pszText = text;
		hdi.cxy = w;
		hdi.lParam = w;
		hdi.cchTextMax = sizeof(hdi.pszText)/sizeof(hdi.pszText[0]); 
	int result = Header_InsertItem( hwndList, Header_GetItemCount(hwndList)+1, &hdi );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void Header_SetSizeScale( HWND hwndList, int w,int h ) {
	int width = Header_GetWidth(hwndList);
	int numitems = Header_GetItemCount(hwndList);
	int wsofar = 0;
	for( int i = 0; i < numitems; i++ ) {
		HDITEM hdi;
			hdi.mask = HDI_WIDTH|HDI_LPARAM;
		Header_GetItem( hwndList, i, &hdi );
			double percentage = double(hdi.lParam)/100.0;
			hdi.cxy = (int)(percentage*w);
			wsofar += hdi.cxy;

			if( i == numitems-1 ) {
				if( wsofar < w ) {
					hdi.cxy += w-wsofar;
				}
			}

		Header_SetItem( hwndList, i, &hdi );
	}
	SetWindowPos( hwndList, 0, 0,0, w,h, SWP_NOZORDER|SWP_NOMOVE|SWP_SHOWWINDOW );
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
