// Update.h | by Doug Manley
///////////////////////////////////////////////////////////
#ifndef UPDATE_H
#define UPDATE_H
///////////////////////////////////////////////////////////
#include "Http.h"

#include <Setupfile\Setupfile.h>
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
/* Update file format;
WHAT :: updates.txt ^_^
CURRENT :: 1.0.4
NEWS :: askfdjaksfjda...
UPDATE :: fksafdjasf...
*/
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
bool IsUpdateFile( char *file ) {
	FILE *f = fopen( file, "rt" );
	if( f ) {
		char buff[256];
		fgets( buff,256-1,f );
		if( strcmp(buff,"WHAT :: updates.txt ^_^\n") == 0 ) {
			return(true);
		} else {
			return(false);
		}
	} else {
		return(false);
	}
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
void Update() {

	SetStatusBarText(L"Checking for updates... (aumaan.home.comcast.net)...");
	bool okay = DownloadFile( "aumaan.home.comcast.net", "JLookUp/updates/updates.txt", "updates.txt" );
	if( okay && IsUpdateFile("updates.txt") ) {
		;
	} else {
		SetStatusBarText(L"Checking for updates... (jlookup.aumaan.no-ip.org)...");
		okay = DownloadFile( "jlookup.aumaan.no-ip.org", "updates/updates.txt", "updates.txt" );

		if( okay && IsUpdateFile("updates.txt") ) {
			;
		} else {
			okay = false;
		}
	}


	if( okay ) {
		SetupFile file;
		if( file.Open( "updates.txt" ) ) {

			string news, current, updates;

			while( !file.eof() ) {
				file.ReadLine();
				if( file.FieldIs("NEWS") ) {
					news += "     ";
					news += file.Parameter() + "\n";
				} else if( file.FieldIs("CURRENT") ) {
					current = file.Parameter();
				} else if( file.FieldIs("UPDATE") ) {
					updates += file.Parameter() + "\n";
				}
			}

			file.Close();


			// See if this version is older than the current:
			bool old = false;
			wstring version = version_info;
#ifndef VERSION_NT
			version = version.substr(0,version.find(L' '));
#endif
			if( version < ToWString(current) ) {
				old = true;
			}



			wstring text = L"***   Please resize this window to read this propery.   ***\n\n";
				text += L"JLookUp\nhttp://jlookup.aumaan.no-ip.org\n\n";
				text += L"N E W S:\n";
				text += ToWString(news);
				text += L"\n\n";
				text += L"Current Version: ";
				text += ToWString(current) + L"\n";
			if( old ) {
				text += L"***\n***   I recommend upgrading ^_^\n***\n";
				text += L"\n" + ToWString(updates);
			} else {
				text += L"***\n***   You seem to be up-to-date ^_^\n***\n";
			}

			
			// Move the divider bar so that the height of the Search Window is 75%
			// of the total height of Search Window + Result Window.
			RECT rcTop = div_main.GetHalf(DIV_TOP)->GetRECT();
			RECT rcBot = div_main.GetHalf(DIV_BOTTOM)->GetRECT();
			int dist = (rcTop.bottom+rcBot.bottom)*3/4 - rcTop.bottom;
			if( dist > 0 ) {
				div_main.MoveBar( (rcTop.bottom+rcBot.bottom)*3/4 - rcTop.bottom );
			}


			// Replace the selection with the search text:
			SETTEXTEX st;
				st.flags = ST_KEEPUNDO;
				st.codepage = 1200; // 1200 == unicode.
			SendMessage( hwnd_searchedit,EM_SETTEXTEX, (WPARAM)&st, (LPARAM)text.c_str() );

			//	Select the text for ease.
			SendMessage( hwnd_searchedit, EM_SETSEL, 0,0 );



			SetStatusBarText(L"Information found.");
		}
	} else {
		SetStatusBarText(L"Update check failed.");
	}
}
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
#endif
///////////////////////////////////////////////////////////
